#include "USBReader.h"

USBReader::USBReader(USBMouseData_Callback data_callback):
  HIDUniversal(&_usb),
  _data_callback(data_callback)
{

}

void USBReader::setup()
{
  if (_usb.Init() == -1)
  {
#ifdef KB_DEBUG
    Serial.println("usb init failed");
#endif
  }
}

void USBReader::loop()
{
  _usb.Task();
}


void USBReader::ParseHIDData(USBHID *hid, bool is_rpt_id, uint8_t len, uint8_t *buf)
{
  KeyReport  MyData={0,0,0,0, 0,0,0,0};

#ifdef KB_DEBUG
  Serial.print("RAW ");
  for (byte i = 0; i < len; i++)
  {
    Serial.print(buf[i], HEX);
    Serial.print(" ");
  }
  Serial.println("");
#endif
  MyData.modifiers=buf[0];
  MyData.reserved=0;
    
  for (byte i = 0; i < 6; i++)
  {
    MyData.keys[i]=buf[i+2];
  }  
  Keyboard.sendReport(&MyData);
  
#ifdef KB_DEBUGx
  Serial.print("RAW ");
  for (byte i = 0; i < len; i++)
  {
    Serial.print(buf[i], HEX);
    Serial.print(" ");
  }
  Serial.println("");
#endif

  if (buf != nullptr && sizeof(USBKeyboardData) == len)
  {
    _data_callback((USBKeyboardData *)buf);
  }
}
