/*
 * USBReader.h - Read data from USB mouse
 *
 * Written by LiuLiu.mz, March 2020.
 *
 */

#ifndef _USB_READER_H_
#define _USB_READER_H_

#include <hiduniversal.h> // https://github.com/felis/USB_Host_Shield_2.0
#include "MacroDef.h"
#include "Keyboard.h"

#pragma pack(1)

// the data struct of my usb mouse, get it with the help of usblyzer
struct USBKeyboardData
{
   char Data[8];
};

typedef void (*USBMouseData_Callback)(USBKeyboardData*);

class USBReader: public HIDUniversal
{
public:
	USBReader(USBMouseData_Callback data_callback);

	void setup();
	void loop();

protected:
    virtual void ParseHIDData(USBHID *hid, bool is_rpt_id, uint8_t len, uint8_t *buf) override;

private:
	USB _usb;
	USBMouseData_Callback _data_callback;
};

#endif //_USB_READER_H_
